'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inputSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomInput-input';

var SIZES = {
  MEDIUM: 'm',
  SMALL: 's'
};

var ERROR_STATES = {
  ERROR: 'error',
  SUCCESS: 'success'
};

var Input = function (_Component) {
  (0, _inherits3.default)(Input, _Component);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Input.__proto__ || (0, _getPrototypeOf2.default)(Input)).call.apply(_ref, [this].concat(args))), _this), _this.changeHandler = function (ev) {
      var onChange = _this.props.onChange;
      var value = ev.target.value;

      onChange(ev, { value: value });
    }, _this.handleKeyDown = function (ev) {
      var _this$props = _this.props,
          onEnter = _this$props.onEnter,
          onEnterKey = _this$props.onEnterKey,
          onKeyDown = _this$props.onKeyDown;
      var value = ev.target.value;
      var key = ev.key;

      onKeyDown(ev, { value: value });
      if (key === onEnterKey) onEnter(ev, { value: value });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Input, [{
    key: 'getErrorStateClass',
    value: function getErrorStateClass(errorState) {
      if (errorState) return BASE_CLASS + '--' + ERROR_STATES.ERROR;
      if (errorState === false) return BASE_CLASS + '--' + ERROR_STATES.SUCCESS;
      return '';
    }
  }, {
    key: 'getClassNames',
    value: function getClassNames(_ref2) {
      var size = _ref2.size,
          charsSize = _ref2.charsSize,
          hideInput = _ref2.hideInput,
          noBorder = _ref2.noBorder,
          readOnly = _ref2.readOnly,
          errorState = _ref2.errorState;

      return (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '-' + size, charsSize && BASE_CLASS + '--size', hideInput && BASE_CLASS + '--hidden', noBorder && BASE_CLASS + '--noBorder', readOnly && BASE_CLASS + '--readOnly', this.getErrorStateClass(errorState));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          checked = _props.checked,
          disabled = _props.disabled,
          readOnly = _props.readOnly,
          hideInput = _props.hideInput,
          noBorder = _props.noBorder,
          id = _props.id,
          name = _props.name,
          onBlur = _props.onBlur,
          onFocus = _props.onFocus,
          placeholder = _props.placeholder,
          reference = _props.reference,
          size = _props.size,
          errorState = _props.errorState,
          type = _props.type,
          value = _props.value,
          charsSize = _props.charsSize,
          tabIndex = _props.tabIndex;


      return _react2.default.createElement('input', {
        className: this.getClassNames({
          size: size,
          charsSize: charsSize,
          hideInput: hideInput,
          noBorder: noBorder,
          readOnly: readOnly,
          errorState: errorState
        }),
        tabIndex: tabIndex,
        checked: checked,
        disabled: disabled || readOnly,
        id: id,
        name: name,
        onChange: this.changeHandler,
        onFocus: onFocus,
        onBlur: onBlur,
        onKeyDown: this.handleKeyDown,
        placeholder: placeholder,
        ref: reference,
        type: type,
        value: value,
        size: charsSize
      });
    }
  }]);
  return Input;
}(_react.Component);

Input.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /* This Boolean attribute prevents the user from interacting with the input */
  disabled: _propTypes2.default.bool,
  /* This Boolean attribute prevents the user from interacting with the input but without disabled styles */
  readOnly: _propTypes2.default.bool,
  /* Mark the input as selected */
  checked: _propTypes2.default.bool,
  /* The DOM id global attribute. */
  id: _propTypes2.default.string,
  /* sets the name property of an element in the DOM */
  name: _propTypes2.default.string,
  /* onBlur callback */
  onBlur: _propTypes2.default.func,
  /* onKeyDown callback */
  onKeyDown: _propTypes2.default.func,
  /* onChange callback */
  onChange: _propTypes2.default.func,
  /* onFocus callback */
  onFocus: _propTypes2.default.func,
  /* onEnter callback */
  onEnter: _propTypes2.default.func,
  /* key to provoke the onEnter callback. Valid any value defined here → https://www.w3.org/TR/uievents-key/#named-key-attribute-values */
  onEnterKey: _propTypes2.default.string,
  /* A hint to the user of what can be entered in the control. The placeholder text must not contain carriage returns or line-feeds. */
  placeholder: _propTypes2.default.string,
  /* 's' or 'm', default: 'm' */
  size: _propTypes2.default.oneOf((0, _values2.default)(SIZES)),
  /* width of input based in number of characters (native "size" attribute) */
  charsSize: _propTypes2.default.number,
  /* text, password, date or number */
  type: _propTypes2.default.string,
  /* value of the control */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),
  /* react ref to access DOM node */
  reference: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]),
  /** Wether to show the input or not */
  hideInput: _propTypes2.default.bool,
  /* Will set a red/green border if set to true/false */
  errorState: _propTypes2.default.bool,
  /** Wether to hide the input border or not */
  noBorder: _propTypes2.default.bool,
  /** tabindex value */
  tabIndex: _propTypes2.default.number
} : {} : {};

Input.defaultProps = {
  size: SIZES.MEDIUM,
  onEnterKey: 'Enter',
  tabIndex: -1,
  onKeyDown: function onKeyDown() {},
  onEnter: function onEnter() {},
  onChange: function onChange() {}
};

exports.default = Input;
exports.inputSizes = SIZES;